using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Web;
using System.Drawing;

namespace NoJava2Lib.FileAccess
{
    /// <summary>
    /// t@C[_[
    /// </summary>
    public class FileReader
    {
        string currentURL;

        public FileReader()
        {
        }

        public FileReader(string currentURL) : this()
        {
            this.currentURL = currentURL;
        }

        /// <summary>
        /// t@CURLԂ
        /// </summary>
        /// <param name="filepath"></param>
        /// <returns></returns>
        string GetFileAddress(string filepath)
        {
            if ((currentURL == null) || (currentURL == string.Empty))
            {
                return filepath;
            }
            string str = filepath.Replace(@"\", @"/");
            return currentURL + @"/" + str;
        }

        /// <summary>
        /// t@C̗LmF
        /// </summary>
        /// <param name="filePath">t@C̃pX</param>
        /// <param name="isLocal">[Jlbg</param>
        /// <returns></returns>
        bool IsFileExist(string filePath, bool isLocal)
        {
#warning b Ƃ֐͂
            if (isLocal)
            {
                return File.Exists(filePath);
            }
            else
            {
                try
                {
                    using (System.Net.WebClient webClient = new System.Net.WebClient())
                    {
                        string URL = GetFileAddress(filePath);
                        using (Stream stm = webClient.OpenRead(URL))
                        {
                            return stm.CanRead;
                        }
                    }
                }
                catch
                {
                    return false;
                }
            }
        }

        /// <summary>
        /// w肳ꂽeLXgt@Cǂ
        /// </summary>
        /// <param name="filePath">t@C̃pX</param>
        /// <returns></returns>
        public string ReadTextFile(string filePath)
        {
            string str;
            using (StreamReader sReader = new StreamReader(filePath))
            {
                str = sReader.ReadToEnd();
            }
            return str;
        }

        /// <summary>
        /// w肵C[Wt@Cǂ
        /// </summary>
        /// <param name="filePath">t@C̃pX</param>
        /// <returns></returns>
        public Bitmap ReadImageFile(string filePath)
        {
            throw new Exception();
        }
    }
}
