using System;
using System.Collections.Generic;
using System.Text;

namespace NoJava2Lib
{
    /// <summary>
    /// قƂǂ̃NX̊{NX
    /// </summary>
    public abstract partial class GameObject
    {
        public enum GameObjectType{GameObject = 0, _ScriptReader = 0xFF00}

        public delegate void OnLoaded();

        #region ϐ
        string name;
        /// <summary>
        /// O
        /// </summary>
        public string Name { get { return name; } }
        /// <summary>
        /// ̃NX̌^ԍ
        /// </summary>
        int type;

        protected static FileAccess.FileReader fileReader;
        GameObject owner;
        /// <summary>
        /// e
        /// </summary>
        public GameObject Owner
        {
            set
            {
                if (owner != null)
                {
                    owner.DisregisterChild(this);
                }
                owner = value;
                owner.RegisterChild(this);
            }
        }
        GameObject[] childs;
        #endregion

        #region Cxg
        public event EventHandler Discreating;
        #endregion

        public GameObject(string name) {
            this.name = name;
            SetType();
        }

        #region ֐
        /// <summary>
        /// 󂯂
        /// </summary>
        /// <param name="orderContents">̓e</param>
        public virtual void TakeOrder(string[] orderContents)
        {
            switch(orderContents[0])
            {
                case "Discreate":
                    Discreate();
                break;
                default:
                    throw new Exception("m̒e");
                    break;
            }
        }

        /// <summary>
        /// vꂽIuWFNgԂ
        /// </summary>
        /// <param name="name"></param>
        /// <returns></returns>
        public GameObject SearchObject(string name)
        {
            GameObject tmpvalue = this;

            if (this.Name != name)
            {
                if( (childs != null)&&( childs.Length == 0))
                {
                    tmpvalue = null;
                }
                else
                {
                    foreach (GameObject child in childs)
                    {
                        tmpvalue = child.SearchObject(name);
                        if (tmpvalue != null)
                        {
                            break;
                        }
                    }
                }
            }

            return tmpvalue;
        }

        /// <summary>
        /// qo^
        /// </summary>
        /// <param name="addChild">q</param>
        public virtual void RegisterChild(GameObject registerChild)
        {
            if (childs == null)
            {
                childs = new GameObject[1];
                childs[0] = registerChild;
            }
            else
            {
                GameObject[] tmpChilds = new GameObject[childs.Length + 1];
                childs.CopyTo(tmpChilds, 0);
                tmpChilds[tmpChilds.Length - 1] = registerChild;
                childs = null;
                childs = tmpChilds;
            }
        }

        /// <summary>
        /// q̓o^
        /// </summary>
        /// <param name="disregisterChild">q</param>
        public virtual void DisregisterChild(GameObject disregisterChild)
        {
            try
            {
                if (childs == null)
                {
                    throw new Exception("Aq΂ɌāH");
                }

                bool isContain = false;
                foreach (GameObject child in childs)
                {
                    if (child == disregisterChild)
                    {
                        isContain = true;
                        break;
                    }
                }
                if (!isContain)
                {
                    throw new Exception("ȂȂĂ̎qႠ܂");
                }

                GameObject[] tmpChilds = new GameObject[childs.Length - 1];
                for (int i = 0, j = 0; j < tmpChilds.Length; i++, j++)
                {
                    if (childs[i] == disregisterChild)
                    {
                        i++;
                    }

                    tmpChilds[j] = childs[i];
                }
                childs = null;
                childs = tmpChilds;
            }
            catch (Exception e)
            {
                // ǂgȂƎv
#if DEBUG
                throw e;
#endif
            }
        }

        public virtual void Save()
        {
            
        }

        public virtual void Load(Stack<OnLoaded> onLoadedFunctions)
        {
        }

        protected virtual void SetType()
        {
            type = (int)GameObjectType.GameObject;
        }

        /// <summary>
        /// 
        /// </summary>
        protected virtual void Discreate()
        {
            //Discreating();
        }
        #endregion

        #region Cxgnh
        #endregion
    }
}
