using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace NoJava2Lib
{
    /// <summary>
    /// XNvgǂނƂ
    /// GameObject̃[gIuWFNg
    /// </summary>
    class ScriptReader : GameObject
    {
        #region ϐ
        public static string[] OrderSeparator = {"," };
        Queue<Scripts.Order> orders;
        #endregion

        #region Cxg
        #endregion

        public ScriptReader(string filePath) : base (@"_[g")
        {
            orders = new Queue<Scripts.Order>();
            fileReader = new FileAccess.FileReader();

            string tmpOrders = fileReader.ReadTextFile(filePath);
            AddOrders(tmpOrders);
        }

        #region ֐
        /// <summary>
        /// ǂ
        /// </summary>
        public bool Read()
        {
            if (orders.Count <= 0)
            {
                return false;
            }

            Scripts.Order order = orders.Dequeue();

            //߂󂯂IuWFNgT
            GameObject orderedObject = SearchObject(order.Name);

            if (orderedObject == null)
            {
                throw new Exception("w肳ꂽIuWFNg݂܂");
            }

            orderedObject.TakeOrder(order.Content);

            return true;
        }



        /// <summary>
        /// ǉ
        /// </summary>
        /// <param name="addOrders">̌</param>
        void AddOrders(string addOrders)
        {
            using (StringReader sreader = new StringReader(addOrders))
            {
                string tmpOrder;
                string name;
                string[] content;

                while ((tmpOrder = sreader.ReadLine()) != null)
                {
                    name = tmpOrder.Substring(0, tmpOrder.IndexOf(OrderSeparator[0]));
                    tmpOrder = tmpOrder.Remove(0, tmpOrder.IndexOf(OrderSeparator[0]) + 1);
                    content = tmpOrder.Split(OrderSeparator, StringSplitOptions.RemoveEmptyEntries);
                    orders.Enqueue(new Scripts.Order(name, content));
                }
            }
        }

        #region ꂽƂ̊֐
        /// <summary>
        /// 󂯂
        /// </summary>
        /// <param name="orderContents">̓e</param>
        public override void TakeOrder(string[] orderContents)
        {
            base.TakeOrder(orderContents);
        }

        void MakeForm(string scriptFilePath)
        {

        }
        #endregion
        #endregion
    }
}
